Public Class fclsMain
    Inherits System.Windows.Forms.Form

    Private m_objDrawingSurface As Bitmap

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents txtInput As System.Windows.Forms.TextBox
    Friend WithEvents btnDrawText As System.Windows.Forms.Button
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.txtInput = New System.Windows.Forms.TextBox
        Me.btnDrawText = New System.Windows.Forms.Button
        Me.SuspendLayout()
        '
        'txtInput
        '
        Me.txtInput.Location = New System.Drawing.Point(56, 184)
        Me.txtInput.Name = "txtInput"
        Me.txtInput.TabIndex = 0
        Me.txtInput.Text = ""
        '
        'btnDrawText
        '
        Me.btnDrawText.Location = New System.Drawing.Point(160, 184)
        Me.btnDrawText.Name = "btnDrawText"
        Me.btnDrawText.TabIndex = 1
        Me.btnDrawText.Text = "Draw Text"
        '
        'fclsMain
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(292, 266)
        Me.Controls.Add(Me.btnDrawText)
        Me.Controls.Add(Me.txtInput)
        Me.Name = "fclsMain"
        Me.Text = "Persisting Graphics Example"
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private Sub fclsMain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Randomize()
        ' Create a drawing surface with the same dimensions as the client
        ' area of the form.
        m_objDrawingSurface = New Bitmap(Me.ClientRectangle.Width, _
                              Me.ClientRectangle.Height, _
                              Drawing.Imaging.PixelFormat.Format24bppRgb)
        InitializeSurface()

    End Sub


    Private Sub InitializeSurface()
        Dim objGraphics As Graphics
        Dim rectBounds As Rectangle

        ' Create a Graphics object that references the bitmap and clear it.
        objGraphics = Graphics.FromImage(m_objDrawingSurface)
        objGraphics.Clear(System.Drawing.SystemColors.Control)

        ' Create a rectangle the same size as the bitmap.
        rectBounds = New Rectangle(0, 0, m_objDrawingSurface.Width, _
                                   m_objDrawingSurface.Height)
        ' Reduce the rectangle slightly so the ellipse won't appear on the border.
        rectBounds.Inflate(-1, -1)

        ' Draw an ellipse that fills the form.
        objGraphics.DrawEllipse(System.Drawing.Pens.Orange, rectBounds)
    End Sub


    Private Sub fclsMain_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles MyBase.Paint

        Dim objGraphics As Graphics
        ' You can't modify e.Graphics directly.
        objGraphics = e.Graphics
        ' Draw the contents of the bitmap on the form.
        objGraphics.DrawImage(m_objDrawingSurface, 0, 0, _
                              m_objDrawingSurface.Width, _
                              m_objDrawingSurface.Height)

    End Sub

    Private Sub btnDrawText_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDrawText.Click

        Dim objGraphics As Graphics
        Dim objFont As Font
        Dim intFontSize As Integer
        Dim intTextX As Integer
        Dim intTextY As Integer
        Dim objRandom As System.Random

        ' If no text has been entered, get out.
        If txtInput.Text = "" Then Exit Sub

        ' Create a graphics object using the memory bitmap.
        objGraphics = Graphics.FromImage(m_objDrawingSurface)

        ' Initialize the Random object.
        objRandom = New Random(Now.Millisecond)

        ' Create a random number for the font size. Keep it between 8 and 48.
        intFontSize = objRandom.Next(8, 48)
        ' Create a random number for X coordinate of the text.
        intTextX = objRandom.Next(0, Me.ClientRectangle.Width - 20)
        ' Create a random number for Y coordinate of the text.
        intTextY = objRandom.Next(0, Me.ClientRectangle.Height - 20)

        ' Create a new font object.
        objFont = New System.Drawing.Font("Arial", intFontSize, _
                                          FontStyle.Bold Or FontStyle.Italic)
        ' Draw the user's text.
        objGraphics.DrawString(txtInput.Text, objFont, _
                               System.Drawing.Brushes.Red, intTextX, intTextY)
        ' Clean up.
        objGraphics.Dispose()
        ' Force the form to paint itself. This triggers the Paint event.
        Me.Invalidate()

    End Sub
End Class
